; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    ltok PROTO :DWORD,:DWORD

    .data
      ln0 db "zero",13,10
      ln1 db "one",13,10
      ln2 db "two",13,10
      ln3 db "three",13,10
      ln4 db "four",13,10
      ln5 db "five",13,10
      ln6 db "six",13,10
      ln7 db "seven",13,10
      ln8 db "eight",13,10
      ln9 db "nine",13,10,0

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pArr  :DWORD
    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL acnt  :DWORD
    LOCAL ptxt  :DWORD

    print "Test correct results",13,10,13,10

  ; ---------------------------------------
  ; display list of words loaded into array
  ; ---------------------------------------
    mov acnt, rv(ltok,OFFSET ln0,ADDR pArr)

    push esi
    push edi

    mov esi, pArr
    mov edi, acnt
  @@:
    print [esi],13,10
    add esi, 4
    sub edi, 1
    jnz @B

  ; ------------------------------
  ; sort and display list of words
  ; ------------------------------
    invoke assort,pArr,acnt,0
    print chr$(13,10)
    print "Above List Sorted",13,10,13,10

    mov esi, pArr
    mov edi, acnt
  @@:
    print [esi],13,10
    add esi, 4
    sub edi, 1
    jnz @B

    pop edi
    pop esi

    free pArr

    print chr$(13,10)
    print "Benchmark algo on file",13,10,13,10

    mov hMem, InputFile("\masm32\include\windows.inc")
    mov flen, ecx

    invoke GetTickCount
    push eax

    mov acnt, rv(ltok,hMem,ADDR pArr)

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print "Milliseconds duration = "
    print str$(eax),13,10

    print "Lines in file = "
    print str$(acnt),13,10,13,10

    free hMem
    free pArr

    ret

main endp

; 

align 4

ltok proc pTxt:DWORD,pArray:DWORD

  ; ---------------------------------------------------------------
  ; tokenise lines in a text source writing an array of pointers
  ; to the address of "pArray" and returning the line count in EAX.
  ; ---------------------------------------------------------------

    .data
    align 4
    actbl \
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    .code

    push ebx
    push esi
    push edi

    mov edi, 1                      ; set counter to 1 in case of no trailing CRLF

    mov esi, pTxt
    sub esi, 1
  ; ----------------
  ; count line feeds
  ; ----------------
  @@:
    add esi, 1
    movzx eax, BYTE PTR [esi]
    test eax, eax                   ; test for terminator
    jz @F
    cmp eax, 10                     ; test for line feed
    jne @B
    add edi, 1                      ; lf count in EDI
    jmp @B
  @@:
  ; --------------------
  ; multiply result by 4
  ; --------------------
    add edi, edi
    add edi, edi
    mov ecx, alloc(edi)             ; allocate pointer array memory

    mov edi, ecx                    ; copy allocated memory address into EDI
    mov esi, pTxt
    xor ebx, ebx                    ; zero arg counter
    sub esi, 1
    jmp ftrim

  ; ---------------------------------

  terminate:
    mov BYTE PTR [esi], 0           ; terminate end of current line

  ftrim:                            ; scan to find next acceptable character
    add esi, 1
    movzx eax, BYTE PTR [esi]       ; zero extend byte
    test eax, eax                   ; test for zero terminator
    jz lout
    cmp BYTE PTR [actbl+eax], 0     ; check it against acceptable character table
    je ftrim

  ; ========
    mov [edi], esi                  ; write current location to pointer
    add edi, 4                      ; set next pointer location
    add ebx, 1                      ; increment arg count
  ; ========

  ttrim:                            ; scan to find the next CR or LF
    add esi, 1
    movzx eax, BYTE PTR [esi]       ; zero extend byte
    test eax, eax                   ; test for zero terminator
    jz lout
    sub eax, 13                     ; test for CR
    jz terminate
    add eax, 3                      ; test for LF
    jz terminate
    jmp ttrim

  ; ---------------------------------

  lout:
    mov esi, pArray                 ; load passed handle address into ESI
    mov DWORD PTR [esi], ecx        ; store local array handle at address of passed handle

    mov eax, ebx                    ; return array count in EAX
    pop edi
    pop esi
    pop ebx

    ret

ltok endp

; 

end start


























